attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp float u_time;
uniform mediump vec4 u_dist_tiling_scroll1;
uniform mediump vec4 u_dist_tiling_scroll2;
uniform mediump vec4 u_dist_strength;
uniform highp vec4 uv_tiling_scroll;
varying lowp vec2 scrollUV0;

varying lowp vec4 v_vcolor;
uniform mediump vec4 rotation_in_x;
	
varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;
varying lowp vec2 v_scrollUV4;

varying lowp vec2 scrollUV3;

varying lowp vec2 v_texCoord;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/
vec2 rotate(vec2 invec, float angle, float offset){
	float rad = radians(angle);
	invec -= vec2(offset);
	invec = vec2(	invec.x*cos(rad) - invec.y*sin(rad), 
						invec.y*cos(rad) + invec.x*sin(rad));
	invec += vec2(offset);
	return invec;
}
// Rotates a 2d texture;
mat2 rotate2d(float _angle){
    return mat2(cos(_angle),-sin(_angle),
                sin(_angle),cos(_angle));
}
void main()
{
	float rotation = rotation_in_x.x;
	float new_time = u_time;
	v_vcolor = a_color;
	v_texCoord = a_texCoord;
	v_scrollUV2 = v_texCoord.xy*u_dist_tiling_scroll2.xy+fract(new_time * u_dist_tiling_scroll2.zw);
	v_scrollUV1 = v_texCoord.xy*u_dist_tiling_scroll1.xy+fract(new_time * u_dist_tiling_scroll1.zw);
	// Rotate uvs according to the vertex color alpha
	v_texCoord -= vec2(0.5);
	v_texCoord = rotate2d(v_vcolor.w*6.3)*v_texCoord;
	v_texCoord += vec2(0.5);

	v_scrollUV4 = v_texCoord.xy;

	// Uncomment if we want to be able to tile the original texture
	scrollUV0 = a_texCoord.xy;//*uv_tiling_scroll.xy+fract(new_time*uv_tiling_scroll.zw);
	scrollUV3 = rotate(scrollUV0, rotation, 0.5);
	
	gl_Position = u_modelViewProjectionMatrix * a_position;
}